# This file is a template, and might need editing before it works on your project.
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages

stages:          # List of stages for jobs, and their order of execution
  - build
  - test
  - deploy

build-job:       # This job runs in the build stage, which runs first.
  stage: build
  variables:
    BUILD_NAME: ""
  script:
    - echo $BUILD_NAME
    - BUILD_NAME=`date "+%Y"`
    - echo BUILD_NAME=$BUILD_NAME >> build.env
    - echo $BUILD_NAME
    - echo "Hello" >> $BUILD_NAME.txt
  artifacts:
    reports:
      dotenv: build.env
    paths:
      - $BUILD_NAME.txt

unit-test-job:   # This job runs in the test stage.
  stage: test    # It only starts when the job in the build stage completes successfully.
  script:
    - echo "Running unit tests... This will take about 60 seconds."
    - echo $BUILD_NAME
    - echo "Code coverage is 90%"

lint-test-job:   # This job also runs in the test stage.
  stage: test
  only:
    - master
  image: registry.gitlab.com/gitlab-org/cloud-deploy/aws-base:latest
  before_script:
    - apt-get update
    - apt-get install zip unzip -y
  script:
    - BUILD_NAME=$APPLICATION_NAME-`date "+%Y%m%d%H%M%S"`
    - echo 1 > 1.txt
    - echo 2 > 2.txt
    - tar cvfz $BUILD_NAME.zip 1.txt 2.txt


deploy-job:      # This job runs in the deploy stage.
  stage: deploy  # It only runs when *both* jobs in the test stage complete successfully.
  script:
    - echo "Deploying application..."
    - echo "Application successfully deployed."

variables:
  BUILD_NAME: "All jobs can use this variable's value"
